\section{Feedback}
Feedback is not what you say, it's how you say it.

\begin{figure}[h!]
  \center
  \includegraphics[width=0.8\textwidth]{feedbacktechniques}
  \caption{Feedback Techniques}
\end{figure}

\paragraph{Giving Feedback}
\begin{itemize}
	\item A first if feedback is welcome
	\item Show appreciation
	\item Keep eye contact
	\item Be honest, but stay objective
	\item Formulate personal statements
	\item Explain why the topics bothers you
\end{itemize}

\paragraph{Receiving Feedback}
\begin{itemize}
	\item Listen carefully before responding
	\item Be grateful for the feedback
	\item Reflect over feedback before making decision
\end{itemize}

\paragraph{Review}
\begin{quote}
	A process or meeting during which a software product is examined by a project personnel, managers, users, customers, user representatives, or other interested parties for comment or approval. - IEEE 1028-2008, Standard for Software Reviews and Audits
\end{quote}

What do we want to review: Architecture, Code, Collaboration, Design, Requirements, Process, Product, Progress, Usability.

\subsection{Process Techniques}

\paragraph{Milestones} \hfill \\
Milestones act as signposts through the course of your project, helping ensure you stay on track. They are perfect candidates for reviewing critical artifacts: project plan, requirements, internal and external designs.  Document milestones with a short description. Use checklist to review progress at milestones.

\paragraph{Daily Scrum} \hfill \\
The purpose of the Daily Scrum is to inspect progress toward the Sprint Goal. It is a 15-minute event for the Developers SCRUM GUIDE.  Held at the same time and place every working day. Developers can select whatever structure and techniques they want, as long it focuses on progress toward the Sprint Goal.

Let the team members stand in a circle. Aim for a duration of under ten minutes, even for large teams. It is okay to do it less often than daily. Let the attendees three questions: What did i do since the last meeting, What will i do until the last meeting, What is in may way?
 
\paragraph{Sprint Review} \hfill \\
Sprint Reviews are important meetings in Scrum and should be prepared accordingly.  In contrast to many books, I recommend starting reviews with a short presentation: Sprint Goal, Sprint Backlog, Open Questions, Project Metrics, Release Planning.

Keys to success sin the sprint review: involve the audience in your demos, PO explains the need of important feature, prepare whiteboards for feedback.

\paragraph{Definition of Done} \hfill \\
The Scrum Guide does not define, what Done means, but it enforces transparency and general acknowledgement. Usually, the Scrum Team creates an initial DoD and improves it over time. The DoD should contain all quality measures necessary to create a shippable increment. In any Sprint Review, only items that are done according to the DoD are shown.

\paragraph{Sprint Retrospective} \hfill \\
The preparation is key. Communicate usefullnes early and often, send invitations early and regularly. Repeat the rules before the meeting starts: vegas rule, be respectful, never interrupt when somebody is speaking, no laptops, no smartphones.
  
\begin{figure}[h!]
  \center
  \includegraphics[width=0.8\textwidth]{retrospective}
  \caption{Retrospective}
\end{figure}

\subsection{Code-oriented Techniques}
\paragraph{Test-Driven Development} \hfill \\
One of the technical practices from Extreme Programming (XP). Development is driven by writing tests before the productive code. While being in “Refactor”, new code is reviewed and improved. Kind of a one-person review – you won’t bother any of your teammates.
   
\paragraph{Rubber Ducking} \hfill \\
Explaining a problem to someone or something often helps finding a solution.  Kind of a one-person review – you won’t bother any of your teammates. As a plus, you do not have to respect any feedback rules while talking to yourself. Use it as a first measure when getting stuck during programming.

\paragraph{Pair Programming} \hfill \\
Two programmers working at one PC: the driver writes the code, the navigator gives constant feedback. Navigator constantly reviews Driver’s work.  Use it for new, complex problems.

Benefits: resulting code has fewer defects, better software design, interrupts can be handled, knowledge transfer (monitoring), happier developers, team building.

Drawbacks: total number of person-hours increases, less suited for open plan offices.

\paragraph{Mob Programming} \hfill \\
Pair Programming just with more attendees: programmers, architects, domain experts. Best suited for: very difficult problems, mission-critical parts of code. Rotate between roles every 5 to 10 minutes.
 
\paragraph{Pull Request} \hfill \\
Systematic reviews using Git:
\begin{enumerate}
	\item A developer makes all changes related to a work item on a dedicated branch 
	\item After finishing, the developer files a pull request 
	\item The rest of the team reviews the code, discusses it (and possibly alters it)
	\item A maintainer merges the feature into one of the stable branches
\end{enumerate}

During step 3, the team usually checks if the Definition of Done was followed. Well supported by many DevOps-tools.

\begin{figure}[h!]
  \center
  \includegraphics[width=0.8\textwidth]{gitworkflow.png}
  \caption{Pull Requests - Gitflow Workflow}
\end{figure}

\paragraph{Code Reviews} \hfill \\
A rather formal way to asses the code, roles, process, artifacts. Are usually performed manually with the support of tools.

\begin{figure}[h!]
  \center
  \includegraphics[width=0.9\textwidth]{codereview}
  \caption{Code Review Process}
\end{figure}